/* cl sukesuke.c /link user32.lib /opt:nowin98 */

#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <wingdi.h>
#include <winuser.h>

// EChEp`
#define	WS_EX_LAYERED 0x80000
#define LWA_ALPHA 2
typedef DWORD (WINAPI *FWINLAYER)(HWND hwnd,DWORD crKey,BYTE bAlpha,DWORD dwFlags);
HWND hWin;

/* "TDSpiceForm","Desktop-Spice" */

char g_winName[1024];
char g_winClass[1024];
char g_findName[1024];
char g_findClass[1024];
int g_trans;
int g_winPosx;
int g_winPosy;
int g_width;
int g_height;

BOOL CALLBACK printWindow(HWND hwnd,LPARAM lparam)
{
	int result;
	LONG info;
	HINSTANCE hDLL;
	FWINLAYER pfWin = NULL;
	WINDOWPLACEMENT place;
	int width,height;
	int left,top;
	LONG style;

	result = GetClassName(hwnd,g_winClass,1024);
	if (result == 0){
		return TRUE;
	}

	result = GetWindowText(hwnd,g_winName,1024);
	if (result == 0){
		return TRUE;
	}
	
	if (g_findClass[0]){
		if (strstr(g_winClass,g_findClass) == NULL){
			return TRUE;
		}
	}

	if (g_findName[0]){
		if (strstr(g_winName,g_findName) == NULL){
			return TRUE;
		}
	}

	/* g͏OB */
	if (strstr(g_winClass,"ConsoleWindowClass") != NULL){
		return TRUE;
	}
	

	style = GetWindowLong(hwnd,GWL_STYLE);	
	if (!(style & WS_VISIBLE)){
		return TRUE;
	}
	if (style & WS_MINIMIZE){
		return TRUE;
	}

	/* EChEʒu擾B */
	memset(&place,0x00,sizeof(WINDOWPLACEMENT));
	place.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(hwnd,&place);

	/* EChE̕ƍ擾B */
	width = place.rcNormalPosition.right - place.rcNormalPosition.left;
	height = place.rcNormalPosition.bottom - place.rcNormalPosition.top;

	if (g_width > 0){
		width = g_width - 1;
	}
	if (g_height > 0){
		height = g_height - 1;
	}

	/* EChËʒu𒲐߂B */
	if (g_winPosx > -1){
		left = g_winPosx;
	}else{
		left = place.rcNormalPosition.left;
		
	}

	if (g_winPosy > -1){
		top = g_winPosy;
	}else{
		top = place.rcNormalPosition.top;
		
	}

	/* EChËʒuݒ肷B */
	place.rcNormalPosition.left = left;
	place.rcNormalPosition.right = left + width;
	place.rcNormalPosition.top = top;
	place.rcNormalPosition.bottom = top + height;

	SetWindowPlacement(hwnd,&place);

	return TRUE;
}

/* IvV */
int parseOption(int argc,char *argv[])
{
	int i;
	int result;
	
	result = 0;

	g_winPosx = -1;
	g_winPosy = -1;
	g_width = -1;
	g_height = -1;
	
	for (i = 1;i < argc;i++){
		if (!strcmp(argv[i],"-class")){
			i++;
			if (i < argc){
				strcpy(g_findClass,argv[i]);
			}
			continue;
		}
		if (!strcmp(argv[i],"-name")){
			i++;
			if (i < argc){
				strcpy(g_findName,argv[i]);
			}
			continue;
		}
		if (!strcmp(argv[i],"-width")){
			i++;
			if (i < argc){
				g_width = atoi(argv[i]);
			}
			continue;
		}
		if (!strcmp(argv[i],"-height")){
			i++;
			if (i < argc){
				g_height = atoi(argv[i]);
			}
			continue;
		}
		if (!strcmp(argv[i],"-X")){
			i++;
			if (i < argc){
				g_winPosx = atoi(argv[i]);
			}
			continue;
		}
		if (!strcmp(argv[i],"-Y")){
			i++;
			if (i < argc){
				g_winPosy = atoi(argv[i]);
			}
			continue;
		}else{
			fprintf(stderr,"Bad option.\n");
			result = 1;
			break;
		}
	}
	return result;
}

int main(int argc,char *argv[])
{
	g_trans = 192;
	g_findName[0] = '\0';
	g_findClass[0] = '\0';

	if (argc < 2){
		fprintf(stderr,"Usage:syugou -class classname -name windowname (-X X_pos) (-Y Y_pos) (-width width) (-height height)\n");
		return 1;
	}

	if (parseOption(argc,argv)){
		return 1;
	}
	
	if (g_findName[0] == '\0' && g_findClass[0] == '\0'){
		fprintf(stderr,"No target is specified.\n");
		return 1;
	}

	EnumWindows(printWindow,0);

	return 0;
}
